{ lib
, poetry2nix
, fetchFromGitHub
, python310
}:

let
  poetryOverrides = poetry2nix.defaultPoetryOverrides.extend (full: prev: {
    nox = prev.nox.overridePythonAttrs (old: {
      buildInputs = old.buildInputs ++ [ prev.setuptools ];
    });
    pip-requirements-parser = prev.pip-requirements-parser.overridePythonAttrs (old: {
      dontConfigure = true;
    });
  });

  src = fetchFromGitHub {
    owner = "tweag";
    repo = "FawltyDeps";
    rev = "2f9338d3ceb0c1954500f2cbede16ce223bfb160";
    sha256 = "sha256-h5jWeJ5ZfrTuGZr14nUFaNFMCRlpBzDxfFKRYTqxFDI=";
  };
in
poetry2nix.mkPoetryApplication {
  version = "2023-03-16";
  python = python310;
  projectDir = "${src}";
  overrides = poetryOverrides;
}
